
//     
typedef struct {
	const char *test_dav_directive;
}test_dav_server_conf;


//   post_config
static int test_dav_post_config(apr_pool_t *p, apr_pool_t *plog,
                                apr_pool_t *ptemp, server_rec *s) {

    //  ,   
    //        
    //   
    // (:      .
    //        :
    // http://apachedev.ru/2006/03/13/problemi-pri-sozdanii-modula/)
	return OK;
}


//    
static void *create_server_config(apr_pool_t *p, server_rec *s){
	test_dav_server_conf *conf = NULL;
	conf = (test_dav_server_conf*)apr_palloc(p, sizeof(*conf));
	return (void*)conf;
}

//  
static const char *test_dav_cmd(cmd_parms *cmd, void *config,
                                const char *arg1){
	test_dav_server_conf *conf;
	//      
	conf = ap_get_module_config(cmd->server->module_config, &test_dav_provider_module);
	//   
	conf->test_dav_directive = apr_pstrdup(cmd->pool, arg1);
	return NULL;
}


//  
static const command_rec test_dav_cmds[] = {
	//     
	AP_INIT_TAKE1("tes_dav_directive", test_dav_cmd, NULL, ACCESS_CONF|RSRC_CONF,
                  "    "),
	{NULL}
};

//  DAV 
static dav_provider test_dav_provider =
{
	&test_dav_hooks_repos,   //   
    &test_dav_hooks_propdb,  //   
    &test_dav_hooks_locks,   // 
    NULL,					 // 
    NULL,                    // 
    NULL				     // 
};

//   
static void register_hooks(apr_pool_t *pconf){

	ap_hook_post_config(test_dav_post_config, NULL, NULL, APR_HOOK_MIDDLE);
	//  DAV 
	dav_register_provider(pconf, "test_dav_provider", &test_dav_provider);
}

//    Apache
module AP_MODULE_DECLARE_DATA test_dav_provider_module = {
    STANDARD20_MODULE_STUFF,
    NULL,
    NULL,
    create_server_config, //   
    NULL,
    test_dav_cmds,	//   
    register_hooks, //  
};
